# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with gcj_support

%if %with gcj_support
%define gcj_support 1
%else
%define gcj_support 0
%endif

%define section   free
%define base_name attributes
%define short_name commons-attributes
%define _binary_payload w9.gzdio
%define _source_payload w9.gzdio
%define _binary_filedigest_algorithm 1
%define _source_filedigest_algorithm 1

Name:           apache-%{short_name}
Version:        2.2
Release:        9%{?dist}
Epoch:          0
Summary:        Apache Commons Attributes Package
Group:          Development/Libraries/Java
License:        ASL 2.0
URL:            http://commons.apache.org/attributes
Source0:        commons-attributes-2.2-src.tar.gz
Source1:        commons-attributes-api-2.2.pom
Source2:        commons-attributes-compiler-2.2.pom
Patch0:         commons-attributes-2.2-plugin_jelly.patch
Patch1:         commons-attributes-2.2-build.patch
Patch2:         commons-attributes-AttributeCompiler.patch
Requires(post): jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5
Requires:  ant
Requires:  qdox >= 0:1.12
BuildRequires:  ant >= 0:1.7
BuildRequires:  ant-junit
BuildRequires:  junit >= 0:3.8.2
BuildRequires:  apache-commons-beanutils
BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  qdox >= 0:1.12
BuildRequires:  xerces-j2
BuildRequires:  xml-commons-jaxp-1.3-apis
%if %{gcj_support}
BuildRequires:  java-gcj-compat-devel
%else
BuildArch:      noarch
%endif
Provides:       jakarta-%{short_name} = %{epoch}:%{version}-%{release}
Obsoletes:      jakarta-%{short_name} < %{epoch}:%{version}-%{release}
Provides:       %{short_name} = %{epoch}:%{version}-%{release}
Obsoletes:      %{short_name} < %{epoch}:%{version}-%{release}
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Commons Attributes enables Java programmers to 
use C#/.Net-style attributes in their code.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Provides:       jakarta-%{short_name}-javadoc = %{epoch}:%{version}-%{release}
Obsoletes:      jakarta-%{short_name}-javadoc < %{epoch}:%{version}-%{release}
Provides:       %{short_name}-javadoc = %{epoch}:%{version}-%{release}
Obsoletes:      %{short_name}-javadoc < %{epoch}:%{version}-%{release}

%description    javadoc
Javadoc for %{name}.

%prep
%setup -q -n %{short_name}-%{version}
%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2

%build
export OPT_JAR_LIST="`%{__cat} %{_sysconfdir}/ant.d/junit`"

export CLASSPATH=$(build-classpath qdox)
CLASSPATH=target/classes:target/test-classes:$CLASSPATH
ant -Dbuild.sysclasspath=only dist

%install
rm -rf $RPM_BUILD_ROOT
install -dm 755 $RPM_BUILD_ROOT%{_javadir}

install -pm 644 dist/%{short_name}-api-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-api-%{version}.jar
install -pm 644 dist/%{short_name}-compiler-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-compiler-%{version}.jar

ln -s %{name}-api-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-api.jar
ln -s %{name}-api-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{short_name}-api-%{version}.jar
ln -s %{short_name}-api-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{short_name}-api.jar
ln -s %{short_name}-api-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/jakarta-%{short_name}-api-%{version}.jar
ln -s %{short_name}-api-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/jakarta-%{short_name}-api.jar
ln -s %{name}-compiler-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-compiler.jar
ln -s %{name}-compiler-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{short_name}-compiler-%{version}.jar
ln -s %{short_name}-compiler-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{short_name}-compiler.jar
ln -s %{short_name}-compiler-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/jakarta-%{short_name}-compiler-%{version}.jar
ln -s %{short_name}-compiler-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/jakarta-%{short_name}-compiler.jar

%add_to_maven_depmap %{short_name} %{short_name}-api %{version} JPP %{short_name}-api
%add_to_maven_depmap %{short_name} %{short_name}-compiler %{version} JPP %{short_name}-compiler

install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -pm 644 %{SOURCE1} \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-api.pom
install -pm 644 %{SOURCE2} \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-compiler.pom

# javadoc
install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr dist/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/jakarta-%{short_name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/jakarta-%{short_name}

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap 
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%doc LICENSE.txt
%{_javadir}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-*%{version}.jar.*
%endif

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/*

%changelog
* Mon Feb 04 2013 Ralph Apel <r.apel@r-apel.de> 0:2.2-9
- Prevent xzpayload problem

* Sat Dec 15 2012 Ralph Apel <r.apel@r-apel.de> 0:2.2-8
- BR qdox >= 0:1.12

* Sat Dec 15 2012 Ralph Apel <r.apel@r-apel.de> 0:2.2-7
- Adapt to qdox-1.12

* Thu Oct 07 2010 Ralph Apel <r.apel@r-apel.de> 0:2.2-6
- Relax BR to jpackage-utils >= 0:1.7.5
- Create compat symlinks for any jakarta-commons-attributes

* Sat Sep 04 2010 Ralph Apel <r.apel@r-apel.de> 0:2.2-5
- OK: move it to free

* Thu Oct 29 2009 Ralph Apel <r.apel@r-apel.de> 0:2.2-4
- rename to apache-commons-attributes
- drop maven1 build

* Thu Mar 19 2009 Ralph Apel <r.apel@r-apel.de> 0:2.2-3.jpp5
- include anttasks.properties in ant build

* Mon Mar 16 2009 David Walluck <dwalluck@redhat.com> 0:2.2-2
- build for JPP-5

* Mon Jul 23 2007 Ralph Apel <r.apel at r-apel.de> - 0:2.2-1jpp
- Upgrade to 2.2
- Add poms and depmap frags
- Add gcj_support option
- Make Vendor, Distribution based on macro
- Adapt (B)Rs

* Sun Mar 12 2006 Fernando Nasser <fnasser@redhat.com> - 0:2.1-6jpp
- Add missing dependency on jakarta-commons-beanutils

* Thu Mar 09 2006 Fernando Nasser <fnasser@redhat.com> - 0:2.1-5jpp
- Add missing dependency on maven-plugin-site

* Fri Feb 24 2006 Ralph Apel <r.apel at r-apel.de> - 0:2.1-4jpp
- compiler jar was almost empty because of typo

* Fri Feb 24 2006 Ralph Apel <r.apel at r-apel.de> - 0:2.1-3jpp
- Switch to maven-1.1 as default build method (--without maven available)
- Build maven plugin

* Thu Oct 07 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.1-2jpp
- Patched build.xml to include anttasks.properties in -compiler.jar

* Fri Oct 01 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.1-1jpp
- First JPackage release
